## org.apache.commons.math.distribution
Class TDistributionImpl

    java.lang.Object
      org.apache.commons.math.distribution.AbstractDistribution
          org.apache.commons.math.distribution.AbstractContinuousDistribution
              org.apache.commons.math.distribution.TDistributionImpl

All Implemented Interfaces:
  java.io.Serializable, ContinuousDistribution, Distribution, TDistribution

    public class TDistributionImpl

extends AbstractContinuousDistribution
implements TDistribution, java.io.Serializable

Default implementation of `TDistribution`.

Version:
  $Revision: 925812 $ $Date: 2010-03-21 11:49:31 -0400 (Sun, 21 Mar 2010) $
See Also:
  Serialized Form

Field Summary
`static double` `DEFAULT_INVERSE_ABSOLUTE_ACCURACY` Default inverse cumulative probability accuracy
`private double` `degreesOfFreedom` The degrees of freedom
`private static long` `serialVersionUID` Serializable version identifier
`private double` `solverAbsoluteAccuracy` Inverse cumulative probability accuracy

Constructor Summary
`TDistributionImpl(double degreesOfFreedom)` Create a t distribution using the given degrees of freedom.
`TDistributionImpl(double degreesOfFreedom, double inverseCumAccuracy)` Create a t distribution using the given degrees of freedom and the specified inverse cumulative probability absolute accuracy.

Method Summary
`double` `cumulativeProbability(double x)` For this distribution, X, this method returns P(X < `x`).
`double` `density(double x)` Returns the probability density for a particular point.
`double` `getDegreesOfFreedom()` Access the degrees of freedom.
`protected double` `getDomainLowerBound(double p)` Access the domain value lower bound, based on `p`, used to bracket a CDF root.
`protected double` `getDomainUpperBound(double p)` Access the domain value upper bound, based on `p`, used to bracket a CDF root.
`protected double` `getInitialDomain(double p)` Access the initial domain value, based on `p`, used to bracket a CDF root.
`protected double` `getSolverAbsoluteAccuracy()` Return the absolute accuracy setting of the solver used to estimate inverse cumulative probabilities.
`double` `inverseCumulativeProbability(double p)` For this distribution, X, this method returns the critical point x, such that P(X < x) = `p`.
`void` `setDegreesOfFreedom(double degreesOfFreedom)` Deprecated. as of 2.1 (class will become immutable in 3.0)
`private void` `setDegreesOfFreedomInternal(double newDegreesOfFreedom)` Modify the degrees of freedom.

Methods inherited from class org.apache.commons.math.distribution.AbstractDistribution
`cumulativeProbability`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.apache.commons.math.distribution.Distribution
`cumulativeProbability`

Field Detail

### DEFAULT_INVERSE_ABSOLUTE_ACCURACY

    public static final double DEFAULT_INVERSE_ABSOLUTE_ACCURACY

  Default inverse cumulative probability accuracy

  Since:
    2.1
  See Also:
    Constant Field Values

### serialVersionUID

    private static final long serialVersionUID

  Serializable version identifier

  See Also:
    Constant Field Values

### degreesOfFreedom

    private double degreesOfFreedom

  The degrees of freedom

### solverAbsoluteAccuracy

    private final double solverAbsoluteAccuracy

  Inverse cumulative probability accuracy

Constructor Detail

### TDistributionImpl

    public TDistributionImpl(double degreesOfFreedom,
                             double inverseCumAccuracy)

  Create a t distribution using the given degrees of freedom and the specified inverse cumulative probability absolute accuracy.

  Parameters:
    `degreesOfFreedom` - the degrees of freedom.
    `inverseCumAccuracy` - the maximum absolute error in inverse cumulative probability estimates (defaults to `DEFAULT_INVERSE_ABSOLUTE_ACCURACY`)
  Since:
    2.1

### TDistributionImpl

    public TDistributionImpl(double degreesOfFreedom)

  Create a t distribution using the given degrees of freedom.

  Parameters:
    `degreesOfFreedom` - the degrees of freedom.

Method Detail

### setDegreesOfFreedom

    @Deprecated
    public void setDegreesOfFreedom(double degreesOfFreedom)

  Deprecated. as of 2.1 (class will become immutable in 3.0)

  Modify the degrees of freedom.

  Specified by:
    `setDegreesOfFreedom` in interface `TDistribution`
  Parameters:
    `degreesOfFreedom` - the new degrees of freedom.

### setDegreesOfFreedomInternal

    private void setDegreesOfFreedomInternal(double newDegreesOfFreedom)

  Modify the degrees of freedom.

  Parameters:
    `newDegreesOfFreedom` - the new degrees of freedom.

### getDegreesOfFreedom

    public double getDegreesOfFreedom()

  Access the degrees of freedom.

  Specified by:
    `getDegreesOfFreedom` in interface `TDistribution`
  Returns:
    the degrees of freedom.

### density

    public double density(double x)

  Returns the probability density for a particular point.

  Overrides:
    `density` in class `AbstractContinuousDistribution`
  Parameters:
    `x` - The point at which the density should be computed.
  Returns:
    The pdf at point x.
  Since:
    2.1

### cumulativeProbability

    public double cumulativeProbability(double x)
                                 throws MathException

  For this distribution, X, this method returns P(X < `x`).

  Specified by:
    `cumulativeProbability` in interface `Distribution`
  Parameters:
    `x` - the value at which the CDF is evaluated.
  Returns:
    CDF evaluted at `x`.
  Throws:
    `MathException` - if the cumulative probability can not be computed due to convergence or other numerical errors.

### inverseCumulativeProbability

    public double inverseCumulativeProbability(double p)
                                        throws MathException

  For this distribution, X, this method returns the critical point x, such that P(X < x) = `p`.

  Returns `Double.NEGATIVE_INFINITY` for p=0 and `Double.POSITIVE_INFINITY` for p=1.

  Specified by:
    `inverseCumulativeProbability` in interface `ContinuousDistribution`
  Overrides:
    `inverseCumulativeProbability` in class `AbstractContinuousDistribution`
  Parameters:
    `p` - the desired probability
  Returns:
    x, such that P(X < x) = `p`
  Throws:
    `MathException` - if the inverse cumulative probability can not be computed due to convergence or other numerical errors.
    `java.lang.IllegalArgumentException` - if `p` is not a valid probability.

### getDomainLowerBound

    protected double getDomainLowerBound(double p)

  Access the domain value lower bound, based on `p`, used to bracket a CDF root. This method is used by `inverseCumulativeProbability(double)` to find critical values.

  Specified by:
    `getDomainLowerBound` in class `AbstractContinuousDistribution`
  Parameters:
    `p` - the desired probability for the critical value
  Returns:
    domain value lower bound, i.e. P(X < lower bound) < `p`

### getDomainUpperBound

    protected double getDomainUpperBound(double p)

  Access the domain value upper bound, based on `p`, used to bracket a CDF root. This method is used by `inverseCumulativeProbability(double)` to find critical values.

  Specified by:
    `getDomainUpperBound` in class `AbstractContinuousDistribution`
  Parameters:
    `p` - the desired probability for the critical value
  Returns:
    domain value upper bound, i.e. P(X < upper bound) > `p`

### getInitialDomain

    protected double getInitialDomain(double p)

  Access the initial domain value, based on `p`, used to bracket a CDF root. This method is used by `inverseCumulativeProbability(double)` to find critical values.

  Specified by:
    `getInitialDomain` in class `AbstractContinuousDistribution`
  Parameters:
    `p` - the desired probability for the critical value
  Returns:
    initial domain value

### getSolverAbsoluteAccuracy

    protected double getSolverAbsoluteAccuracy()

  Return the absolute accuracy setting of the solver used to estimate inverse cumulative probabilities.

  Overrides:
    `getSolverAbsoluteAccuracy` in class `AbstractContinuousDistribution`
  Returns:
    the solver absolute accuracy
  Since:
    2.1

Copyright (c) 2003-2010 Apache Software Foundation